/*
* ##################################################### Start StatusPage Addon #####################################################
*/

var numTvs = 4;
var tvIpParameter = 1;
var tvTextParameterHostname = 21;
var tvOnOffStatusCo = 11;
var tvErrorIndicationCo = 1;
var tvLastErrorCo = 2;
var tvCoOffset = 100;
var useHostname = new Array(numTvs);
var tvIp = new Array(numTvs);
var tvOnOffStatusCos = new Array(numTvs);
var tvErrorIndicationCos = new Array(numTvs);
var tvLastErrorCos = new Array(numTvs);
var tvInformation = ["tv1_information", "tv2_information", "tv3_information", "tv4_information"];
for (i = 0; i < numTvs; i++)
{
  tvOnOffStatusCos[i] = tvOnOffStatusCo + i * tvCoOffset;
  tvErrorIndicationCos[i] = tvErrorIndicationCo + i * tvCoOffset;
  tvLastErrorCos[i] = tvLastErrorCo + i * tvCoOffset;
}

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  
  parentElement.appendChild(span);
  parentElement = span;
  
  this.tvHostname = new Array(numTvs);

  var tvInfo = new Array(numTvs);
  var tvSpan = new Array(numTvs);
  var tvStatusUpdateFunction = new Array(numTvs);
  for (i = 0; i < numTvs; i++)
  {
    tvInfo[i] = document.createElement('b');
    tvInfo[i].appendChild(document.createTextNode(i18n.translate(tvInformation[i]) + ': ' + i18n.translate('device_not_projected')));
    tvInfo[i].appendChild(document.createElement('br'));
    parentElement.appendChild(tvInfo[i]);
    
    tvSpan[i] = document.createElement('span');
    tvSpan[i].setAttribute('hidden', '');
    parentElement.appendChild(tvSpan[i]);
  }
  
  var updateTVStatus = function(index) {
    var ipOrHostname = thisClass.tvHostname[index] || tvIp[index];
    if (ipOrHostname != undefined) {
      while (tvInfo[index].hasChildNodes()) {
        tvInfo[index].removeChild(tvInfo[index].childNodes[0]);
      }
      if (ipOrHostname != "" && ipOrHostname != "0.0.0.0") {
        tvInfo[index].appendChild(document.createTextNode(i18n.translate(tvInformation[index]) + ': ' + ipOrHostname), tvInfo[index].childNodes[0]);
        tvInfo[index].appendChild(document.createElement('br'));
        tvSpan[index].removeAttribute('hidden');
      } else {
        tvInfo[index].appendChild(document.createTextNode(i18n.translate(tvInformation[index]) + ': ' + i18n.translate('device_not_projected')));
        tvInfo[index].appendChild(document.createElement('br'));
      }
    } else {
      tvIp[index] = undefined;
      thisClass.tvHostname[index] = undefined;
      tvSpan[index].setAttribute('hidden', '');
      while (tvInfo[index].hasChildNodes()) {
        tvInfo[index].removeChild(tvInfo[index].childNodes[0]);
      }
    }
  };
  
  thisClass.dataBindings.push(
    function(){
      if (mainSite.appState) {
        if (mainSite.appState.state == 'Running') {
          IscWebService("getNumberParameter", {"number": 1}, function(response){
            if (response.data != undefined && response.data.value) {
              var unsignedNumberParameter = response.data.value >>> 0;
              var mask = 0x80000000;
              for (i = 0; i < numTvs; i++){
                newUseHostname = (unsignedNumberParameter & (mask >>> i)) != 0;
                if (newUseHostname != useHostname[i]){
                  thisClass.tvHostname[i] = undefined;
                  tvIp[i] = undefined;
                }
                useHostname[i] = newUseHostname;
                if (useHostname[i] && thisClass.tvHostname[i] == undefined){
                  var textParameterNumber = tvTextParameterHostname + i;
                  IscWebService("getTextParameter", {"number": textParameterNumber}, function(i, responseTextParameter) {
                    if (responseTextParameter.data != undefined){
                      thisClass.tvHostname[i] = "";
                      if(responseTextParameter.data.value) {
                        thisClass.tvHostname[i] = responseTextParameter.data.value;
                        updateTVStatus(i);
                      }
                    }
                  }.bind(this, i), false);
                }
                if (!useHostname[i] && tvIp[i] == undefined){
                  var ipParameterNumber = tvIpParameter + i;
                  IscWebService("getIpParameter", {"number": ipParameterNumber}, function(i, responseIpParameter) {
                    if (responseIpParameter.data != undefined && responseIpParameter.data.value) {
                      tvIp[i] = responseIpParameter.data.value;
                      updateTVStatus(i);
                    }
                  }.bind(this, i), false);
                }
              }
            }
          }, false);
        }
      }
    }
  );
  

  //add translation elements  ('co_state_' + CONumber) to translation files

  for (i = 0; i < numTvs; i++) {
    this.appendDOMFragmentKimCoInfoTo(tvSpan[i], tvOnOffStatusCos[i]);
    tvSpan[i].appendChild(document.createElement('br'));
    this.appendDOMFragmentKimCoInfoTo(tvSpan[i], tvErrorIndicationCos[i]);
    tvSpan[i].appendChild(document.createElement('br'));
    this.appendDOMFragmentKimCoInfoTo(tvSpan[i], tvLastErrorCos[i]);
    tvSpan[i].appendChild(document.createElement('br'));
  }
  var thisClass = this;

}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  // Enable this for CO Infos.
  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}
//Example for default handling of Boolean COs and specific String COs handling
StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
	
 /*
  * Fernseher on/off CO 11 / 111
  * Fehler vorhanden (aktiv) CO 1 / 101
  * Letzter Fehlertext CO 2 / 102
  */
	
  switch (currentCO.id) {
    case tvLastErrorCos[0]:
    case tvLastErrorCos[1]:
    case tvLastErrorCos[2]:
    case tvLastErrorCos[3]:
      textNode.nodeValue = i18n.translate(currentCO.value);
      break;
    case tvErrorIndicationCos[0]:
    case tvErrorIndicationCos[1]:
    case tvErrorIndicationCos[2]:
    case tvErrorIndicationCos[3]:
     if (currentCO.value == '1') {
       span.setAttribute('class', 'text--error bold');
       textNode.nodeValue = i18n.translate('active');
     } else if (currentCO.value == '0') {
       span.setAttribute('class', 'text--muted');
       textNode.nodeValue = i18n.translate('inactive');
     }
      break;
    case tvOnOffStatusCos[0]:
    case tvOnOffStatusCos[1]:
    case tvOnOffStatusCos[2]:
    case tvOnOffStatusCos[3]:
     if (currentCO.value == '1') {
       span.setAttribute('class', 'text--success');
       textNode.nodeValue = i18n.translate('on').toLowerCase();
     } else if (currentCO.value == '0') {
       span.setAttribute('class', 'text--success');
       textNode.nodeValue = i18n.translate('off').toLowerCase();
     }
      break;
    default:
      //     if (currentCO.value == '1') {
      //       span.setAttribute('class', 'text--success');
      //       textNode.nodeValue = i18n.translate('True');
      //     } else if (currentCO.value == '0') {
      //       span.setAttribute('class', 'text--error');
      //       textNode.nodeValue = i18n.translate('False');
      //     }
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */
